/* File Name: main.cpp */

/*
************************************************************************
************************************************************************

Copyright © 1998 Multimedia Integration Products, All Rights Reserved

This file is not for public release.
************************************************************************

************************************************************************
************************************************************************ */


#include "main.h"

#include "BVCApp.h"

BPath	repositoryPath;
BPath	workDirPath;

char	userName[B_OS_NAME_LENGTH];
char	password[B_OS_NAME_LENGTH];
bool	deleteAfterCheckin;
bool 	remoteRepository;
char	serverAddress[100] = "";


void main()
{
	deleteAfterCheckin = true;
	
	BVCApp * myApp;
	
	myApp = new BVCApp();
	myApp->Run();
	
	delete myApp;
}


// *********************************************//************
status_t FileToStream(BPath * filePath, BMessage * msg, const char * dataField,
								const char * fileNameField, const char * module)
{
	status_t	err;
	off_t		fileLength;
	char		* buf;
	
	char		fileName[B_PATH_NAME_LENGTH];
	
	strcpy(fileName, filePath->Path());
	
	BFile theFile(fileName, B_READ_ONLY);
	
	err = theFile.InitCheck();
	if (err != B_OK)
		return err;
	
	err = theFile.GetSize(&fileLength);
	if (err != B_OK)
		return err;
	 
	buf = new char[fileLength];
	
	err = theFile.Read(buf, (size_t)fileLength);
	
	if (err != fileLength)
		beep();

	err = msg->AddData(dataField, B_RAW_TYPE, buf, fileLength, false, 10);
	if (err != B_OK)
		beep();
	
	err = msg->AddString(fileNameField, module);
	delete buf;
	
	return B_OK;
}

// ********************************************//************
status_t MakeFileFromBuffer(const char * buffer, const char * fileName, ssize_t size)
{
	status_t	err;
	
	BFile	file(fileName, B_WRITE_ONLY | B_CREATE_FILE | B_ERASE_FILE);
	
	err = file.InitCheck();
	if (err != B_OK)
		return err;
	err = file.Write(buffer, size); //If successful err is the size of written file
	if (err == B_NOT_ALLOWED)
		return err;
	if (err == B_DEVICE_FULL)
		return err;
	
	return B_OK; //err should have the size of the file written, not an error message
}