/* File Name: PrefsWindow.h */

/*
************************************************************************
************************************************************************

Copyright © 1998 Multimedia Integration Products, All Rights Reserved

This file is not for public release.
************************************************************************

************************************************************************
************************************************************************ */


#pragma once
	
enum
{
	BVC_PREFS_PICK_REPOSITORY	= 'vcp0',	// Pick Repository
	BVC_PREFS_PICK_WORK_DIR,				// Pick Work Directory
	BVC_PREFS_REPOSITORY_CHOSEN,			// User picked which local repos.
	BVC_PREFS_LOCAL_REPOS,					// Local Repository Radio Button checked
	BVC_PREFS_REMOTE_REPOS,					// Remote Repository Radio Button checked
	BVC_PREFS_WORK_DIR_CHOSEN,
	BVC_PREFS_OK,
	BVC_PREFS_CANCEL
};

class PrefsWindow : public BWindow 
{
public:
					PrefsWindow();
					~PrefsWindow();
					
	virtual	bool	QuitRequested();
	virtual void	MessageReceived(BMessage * message);
	
private:
										// Which = true for repository, false for workDir
	void			MakeFilePanel(const char * name, uint32 command, BFilePanel * which);	
	void			SavePrefs();
	bool			confirmClose;		// When you click a button to close the window, you don't
										// want to confirm it, but when you close it with the tab, you do
										// = true to confirm quit
	
	BPath			tempRepositoryPath,
					tempWorkDirPath;


	BView			* winView;
	
	BTextControl	* userNameView;
	BTextControl	* passwordView;

	BBox			* workDirBox,
					* repositoryBox;
	
	BRadioButton	* localReposRadio,
					* remoteReposRadio;
	
	BCheckBox		* deleteAfterPrefBox;
	
	BStringView		* repositoryView;
	BFilePanel		* repositoryFilePanel;
	BTextControl	* remoteRepositoryView;
	BButton			* pickReposButton;
	
	BStringView		* workDirView;
	BFilePanel		* workDirFilePanel;
	
	void			LayoutWindow();
};

