/* File Name: SourceControlWindow.h */

/*
************************************************************************
************************************************************************

Copyright © 1998 Multimedia Integration Products, All Rights Reserved

This file is not for public release.
************************************************************************

************************************************************************
************************************************************************ */


#pragma once

#include "ColumnListView.h"
#include "CLVColumn.h"
#include "PrefsWindow.h"
#include "ModuleItem.h"

class SourceControlWindow : public BWindow 
{
public:
					SourceControlWindow();
					~SourceControlWindow();
					
	virtual	bool	QuitRequested();
	virtual void	MessageReceived(BMessage * message);

	void			GetModulesFromRepos();
private:
	ColumnListView	* moduleList;
		
	void			SetupMenus();
	void			SetupListView();
	
	
	PrefsWindow		* prefsWindow;
	
	void			LoadModuleList(BMessage * modList);			//Loads the modules from the MakeModuleList's BMessage
	
	status_t		CheckIn(BMessage * msg);
	status_t		Update(BMessage * msg);
	status_t		CheckOut();
	
	status_t		ZipModule(const char * path, BMessage * msg); //zip the module folder at path and shove into the module dtad field of msg
	status_t		UnZipModule(BMessage * msg, const char * destination); //Unzips all the modules into destination
	
	
	status_t		SendToRepos(BMessage *msg);					//Send the message to the repository, remote or local
};

