/*
************************************************************************
************************************************************************

Copyright © 1998 Multimedia Integration Products, All Rights Reserved

This file is for public release.

This file is for reference use only. Any redistribution must include
the entire BeVC package, including source code. If you use this code
please notify j-onorato@uchicago.edu or jwhamil@students.wisc.edu

************************************************************************
Somewhat hacked. Really want Be to do multiuser.
************************************************************************
************************************************************************ */


#include "SecurityManager.h"



// *******************************************//************
bool AuthenticateUser(const char * user, const char * passwdEncoded)
{
	status_t	err;
	BPath		personPath;
	char		savedPasswd[256];
	
												// Get Person File
	err = find_directory(B_COMMON_DIRECTORY, &personPath);
	if (err != B_OK)
		return false;
	
	personPath.Append("people");
	personPath.Append(user);

	BNode		personNode(personPath.Path());
	attr_info	info;
	
	err = personNode.InitCheck();
	if (err != B_OK)
		return false;	

												// Get their password
	err = personNode.GetAttrInfo(SM_PASSWORD_ATTR, &info);
	if (err != B_OK)
		return false;
	
	if (info.type != B_STRING_TYPE)
		return false;
	
	size_t	bytesRead;
	bytesRead = personNode.ReadAttr(SM_PASSWORD_ATTR, B_STRING_TYPE, 0, savedPasswd, info.size);
	
	savedPasswd[bytesRead] = '\0';				// Just make sure it's null terminated
	
												// Compare their password
	if (strcmp(passwdEncoded, savedPasswd) != 0)
		return false;
	
	return true;
}

// *******************************************//************
status_t ChangePassword(const char * user, const char * passwdUnencoded)
{
	status_t	err;
	BPath		personPath;
	char		passwdEncoded[256];
	
												// Get Person File
	err = find_directory(B_COMMON_DIRECTORY, &personPath);
	if (err != B_OK)
		return err;
	
	personPath.Append("people");
	personPath.Append(user);
	
	BNode		personNode(personPath.Path());
	
	err = personNode.InitCheck();
	if (err != B_OK)
		return err;	
	
	attr_info	info;
	
												// Kill whatever's there
	personNode.RemoveAttr(SM_PASSWORD_ATTR);
	
												// If passwd is empty, then just delete the attr
	if (strncmp(passwdUnencoded, "", B_OS_NAME_LENGTH) != B_OK)
	{
												// Encode the password -----------
		strcpy(passwdEncoded, passwdUnencoded);
		
												// Write the attribute
		err = personNode.WriteAttr(SM_PASSWORD_ATTR, B_STRING_TYPE, 0,
							passwdEncoded, strlen(passwdEncoded) + 1);
		if (err != B_OK)
			return err;
	}
	return B_OK;	
}






